<?php


define('MSGDLG_TIP',0);
define('MSGDLG_INFO',1);
define('MSGDLG_WARN',2);
define('MSGDLG_ERROR',3);
define('MSGDLG_FATAL',4);

define('MSGDLG_YESNO',8);
define('MSGDLG_OK',16);



function Dialog($type,$title,$msg) {
  global $pagehead_sent,$pagelogo_sent;

  if (!function_exists('PageHead')) {
    require_once(PRG_PATH . 'core/html.php');
  }
  if (!$pagehead_sent)
    PageHead("","0");
  if (!$pagelogo_sent)
    PageLogo();

  
  $a=func_get_args();
  switch (func_num_args()) {
    case 4: $str=sprintf($msg,$a[3]); break;
    case 5: $str=printf($msg,$a[3],$a[4]); break;
    case 6: $str=printf($msg,$a[3],$a[4],$a[5]); break;
    case 7: $str=printf($msg,$a[3],$a[4],$a[5],$a[6]); break;
    case 8: $str=printf($msg,$a[3],$a[4],$a[5],$a[6],$a[7]); break;
    default: $str=$msg;
  }
 
        
  if ($type==MSGDLG_YESNO) {
    if (!$title) $title=x("Confirmation");
    WinStart($title);
    TItem($str);
    TNext();
    TItem("<BR>".InputSubmit("dlg_yes",' '.x("Yes").' ').'&nbsp;&nbsp;&nbsp;'.InputSubmit("dlg_no",' '.x("No").' '),'ALIGN="center"');
    WinEnd();
  }
  
  if ($type==MSGDLG_OK) {
    if (!$title) $title=x("Information");
    WinStart($title);
    TItem($str);
    TNext();
    TItem("<BR>".InputSubmit("dlg_ok",x("OK")),'ALIGN="center"');
    WinEnd();
  }
}


function Msg($type,$title,$msg) {
  global $pagehead_sent,$pagelogo_sent;
  if (!function_exists('PageHead')) {
    require_once(PRG_PATH . 'core/html.php');
  }
  if (!$pagehead_sent)
    PageHead("","0");
  if (!$pagelogo_sent)
    PageLogo();
  
  switch ($type) {
    case MSGDLG_TIP:
      $xtitle=x("Tip");
      $ihref=PRG_PATH.PRG_M_TIP;
      break;
    case MSGDLG_INFO:
      $xtitle=x("Information");
      $ihref=PRG_PATH.PRG_M_INFO;
      break;
    case MSGDLG_WARN:
      $xtitle=x("Warning");
      $ihref=PRG_PATH.PRG_M_WARN;
      break;
    case MSGDLG_ERROR:
      $xtitle=x("Error");
      $ihref=PRG_PATH.PRG_M_ERROR;
      break;
    case MSGDLG_FATAL:
      $xtitle=x("Fatal Error");
      $ihref=PRG_PATH.PRG_M_FATAL;
      break;
  }
  
  if (!$title)
    $title=$xtitle;

  $msglen=0;
  if (is_array($msg)) {
    foreach($msg as $mmm)
      $msglen+=strlen($mmm);
    reset($msg);
  }
  else
    $msglen=strlen($msg);
  $width=400;
  if ($msglen>256)
    $width=640;  

  echo "<BR>\n";
  echo "<TABLE CLASS=\"msg_back\" WIDTH=\"$width\" BORDER=\"2\" CELLSPACING=\"1\" CELLPADDING=\"0\">\n";
  echo "<TR><TD>\n";
  echo "<TABLE CLASS=\"msg_fore\" WIDTH=\"100%\" BORDER=\"0\">\n";
  echo "<TR>";
  echo "<TD WIDTH=\"50\" ALIGN=\"center\"><IMG SRC=\"$ihref\" ALT=\"$xtitle\"></TD>";
  
  echo "<TD><B>$title</B><BR>";
  
  if (is_array($msg)) {
    switch (count($msg)) {
      case 2: printf($msg[0],$msg[1]); break;
      case 3: printf($msg[0],$msg[1],$msg[2]); break;
      case 4: printf($msg[0],$msg[1],$msg[2],$msg[3]); break;
      case 5: printf($msg[0],$msg[1],$msg[2],$msg[3],$msg[4]); break;
      case 6: printf($msg[0],$msg[1],$msg[2],$msg[3],$msg[4],$msg[5]); break;
      default: echo $msg[0];
    }
  }
  else
    echo $msg;
  echo "</TD>";
  echo "</TR>\n";
 
  
  echo "</TABLE>\n";
  echo "</TD></TR>\n";
  echo "</TABLE>\n";
  echo "<BR>\n";
  
  if ($type==MSGDLG_FATAL) {
    echo "</BODY></HTML>\n";
    die();
  }
}



function MsgTip($msg) {
  $a=func_get_args();
  Msg(MSGDLG_TIP,"",$a);
}

function MsgInfo($msg) {
  $a=func_get_args();
  Msg(MSGDLG_INFO,"",$a);
}

function MsgWarn($msg) {
  $a=func_get_args();
  Msg(MSGDLG_WARN,"",$a);
}

function MsgError($msg) {
  $a=func_get_args();
  Msg(MSGDLG_ERROR,"",$a);
}

function MsgFatal($msg) {
  $a=func_get_args();
  if (defined('PRG_HOMEMAIL'))
    $a[0].="<br/><br/><a href=\"mailto:".PRG_HOMEMAIL."\">Send email to the technical support</a>";
  Msg(MSGDLG_FATAL,"",$a);
}


?>