<?php
define('HELPMARK','config_devices.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');

getGlobalVar('btn_save',$btn_save);

getGlobalVar('id',$id);
getGlobalVar('coll_ip',$coll_ip);
getGlobalVar('coll_port',$coll_port);
getGlobalVar('dev_type',$dev_type);
getGlobalVar('dev_ver',$dev_ver);
getGlobalVar('dev_source',$dev_source);
getGlobalVar('dev_mls',$dev_mls);

getGlobalVar('SERVER_ADDR',$server,PRG_SERVER);

PageHead();
PageLogo();
MenuStart('options','MySubMenu');
PageTitle(x("Cisco NetFlow Configurator"),'i_device.gif');
RequireRights("options");

demo_die();

$list_sampling=array();
$list_sampling['auto']=x("Autodetect");
$list_sampling['manual']=x("Use sampling rate");

$list_type=array();
$list_type['ios']=x("IOS");
$list_type['catos']=x("CatOS");
$list_type['natios']=x("Native IOS");

$list_ver=array();
$list_ver['1']=x("1");
$list_ver['5']=x("5");
$list_ver['6']=x("6");
$list_ver['7']=x("7");
$list_ver['9']=x("9");

if (!$id)
  MsgFatal(x("Unknown device, go to Options-&gt;Devices first."));

$v=SQL_escape($id);
$res=SQL_query("SELECT name,ip,snmp_enabled,snmp_community,sampling,sampling_rate FROM x_device WHERE id='$v'");
if ($res) {
  $row=SQL_fetch_array($res);
  $name=$row[0];
  $ip=$row[1];
  $snmp=$row[2];
  $community=$row[3];
  $sampling=$row[4];
  $sampling_rate=$row[5];
  SQL_free_result($res);
}
else
  MsgError(x("Database error"));

if (!$ip || !$snmp)
  MsgFatal(x("Selected device has not assigned IP address and/or enabled SNMP"));

if (!$coll_port)
  $coll_port=2000;
if (!$dev_ver)
  $dev_ver='5';
if (!$dev_type)
  $dev_type='ios';

if (!$coll_ip)
  $coll_ip=$server;

FormStart();
echo InputHidden("id",$id);
WinStart(x("NetFlow Export Parameters"));
TItem(x("Device:"));
TItem($name);
TNext();
TItem(x("Device IP address:"));
TItem($ip);
TNext();
TItem(x("Collector IP address (*):"));
TItem(Input("coll_ip",$coll_ip,255));
TNext(); 
TItem(x("Collector port (*):"));
TItem(Input("coll_port",$coll_port,5));
TNext(); 
TItem(x("Device system type (*):"));
TItem(InputSelect("dev_type",select_list($list_type,$dev_type)));
TNext(); 
TItem(x("NetFlow version (*):"));
TItem(InputSelect("dev_ver",select_list($list_ver,$dev_ver)));
TNext(); 
TItem(x("Device source interface:"));
TItem(Input("dev_source",$dev_source,32));
TNext(); 
TItem(InputCheck("dev_mls",'1',i_chk($dev_mls)).x("device with MLS capability"),'COLSPAN="2"');
TNext(); 
TItem("<BR>".InputSubmit("btn_save",x("Generate")),'COLSPAN="2" ALIGN="center"');
WinEnd();
FormEnd();

if ($btn_save) {
  if (!is_ip($coll_ip)) {
    MsgError(x("Collector IP address is required.")); 
    $btn_save="";
  }
  elseif ($coll_port<1024 || $coll_port>65535) {
    MsgError(x("Collector port must be in range 1024-65535.")); 
    $btn_save="";
  }
  else {
    $ifDescr		= @my_snmpwalk($ip,$community,".1.3.6.1.2.1.2.2.1.2");
    $ifType		= @my_snmpwalk($ip,$community,".1.3.6.1.2.1.2.2.1.3");
    if (!is_array($ifDescr) || !count($ifDescr)) {
      MsgError(x("Cannot load interface list for selected device; check SNMP setting"));
      $btn_save="";
    }
  }
  if ($dev_ver!=7 && $dev_type=='catos')
    MsgWarn(x("On Cat OS is preferred version 7. Selected version may not be supported."));  
  if ($dev_ver!=7 && $dev_type=='natios')
    MsgWarn(x("On Native IOS is preferred version 7. Selected version may not be supported."));  
}

if ($btn_save) {
  echo "<PRE>\n";
  switch ($dev_type) {
    case 'catos':
      echo "set mls agingtime long 128\n";
      echo "set mls agingtime 32\n";
      echo "set mls flow full\n";
      echo "set mls nde version $dev_ver\n";
      echo "set mls nde $coll_ip $coll_port\n";
      echo "set mls nde enable\n";
      break;
    case 'natios':
      echo "config term\n";
      while (list($key,$if) = each($ifDescr)) {
	if (  (preg_match("#ethernet#i",$if)&&preg_match("#ether#i",$ifType[$key]))||
	      (preg_match("#^pos#i",$if)&&preg_match("#pos#i",$ifType[$key]))||
	      (preg_match("#^vlan#i",$if))||
	      (preg_match("#loopback#i",$ifType[$key]))
	) {
	  echo "interface $if\n";
	  echo " ip route-cache flow\n";
	  echo " exit\n";
	}
	if (!$dev_source && preg_match("#loopback#i",$ifType[$key]))
	  $dev_source=$if;
      }
      echo "\n";
      echo "mls aging long 128\n";
      echo "mls aging normal 32\n";
      echo "mls nde sender version $dev_ver\n";
      echo "ip flow-export destination $coll_ip $coll_port\n";
      if ($dev_source)
        echo "ip flow-export source $dev_source\n";
      if ($dev_mls) {
	echo "mls flow ip full\n";
	echo "mls flow ip interface-full\n"; /* HACK in some IOS version is available only full option */
	echo "mls nde interface\n"; /* HACK in some IOS version is available only full option */
      }
      if ($dev_ver==9) { 
       echo "ip flow-export template timeout-rate 1\n";
      }
      echo "exit\n\n";
      break;

    default:
      echo "config term\n";
      while (list($key,$if) = each($ifDescr)) {
	if (  (preg_match("#ethernet#i",$if)&&preg_match("#ether#i",$ifType[$key]))||
	      (preg_match("#^pos#i",$if)&&preg_match("#pos#i",$ifType[$key]))||
	      (preg_match("#^vlan#i",$if))||
	      (preg_match("#loopback#i",$ifType[$key]))
	) {
	  echo "interface $if\n";
	  echo " ip route-cache flow\n";
	  echo " exit\n";
	}
	if (!$dev_source && preg_match("#loopback#i",$ifType[$key]))
	  $dev_source=$if;
      }
      echo "\n";
      echo "ip flow-cache timeout inactive 10\n";
      echo "ip flow-cache timeout active 5\n";
      echo "ip flow-export version $dev_ver\n";
      echo "ip flow-export destination $coll_ip $coll_port\n";
      if ($dev_source)
        echo "ip flow-export source $dev_source\n";
      if ($dev_mls) {
	echo "mls flow ip full\n";
	echo "mls flow ip interface-full\n"; /* HACK in some IOS version is available only full option */
      }
      if ($dev_ver==9) { 
       echo "ip flow-export template timeout-rate 1\n";
      }
      echo "exit\n\n";
      break;
  }
  echo "</PRE>\n";
}

MenuEnd();
PageTail();



function MySubMenu() {
  $mysubmenu[]=array('caption'=>x("List"),'url'=>'devices.php');
  $mysubmenu[]=array('caption'=>x("Add"),'url'=>'devices.php?command=add');
  $mysubmenu[]=array('caption'=>x("Discover"),'url'=>'devices_dc.php');
  MenuSub(x("Devices"),$mysubmenu);
}


?>