<?php
define('HELPMARK','configuration.html#config_global');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');

/* REGISTERED GLOBAL VARIABLES */
$glvars=array('email','email_login','email_bug','check_update','check_db','style','mstyle','msstyle','community','info_last','info_lic','stat_allow','stat_cols',
    'util_allow','util_hist','util_sizex','util_sizey','util_persec','util_bits','util_clean','eauth_allow','eauth_cmd','ldap_allow',
    'ldap_host','ldap_bind','dns_allow','dns_pos','dns_neg','grpico','grpico_x','grpico_y','grpico_alpha','anon_allow','anon_user','graph_aa');

reset($glvars);
foreach ($glvars as $glvar)
  getGlobalVar($glvar,$$glvar);

getGlobalVar('command',$command);
getGlobalVar('btn_save',$btn_save);


PageHead();
PageLogo();
MenuStart('options');
PageTitle(x("Global settings"),'i_global.gif');
RequireRights("options");

check_command('editsubmit');

demo_cmd("editsubmit");

$list_style=load_styles();
$list_user=list_table("x_user","ORDER BY name");
$list_grpico=list_table("x_imagestore","WHERE grp='_GRAPH_ICON' ORDER BY name");

$list_mstyle['list']=x("List");
$list_mstyle['tile']=x("Tile");

$list_msstyle['']=x("Left full menu");
$list_msstyle['top']=x("Top short menu");

if (!function_exists("ldap_connect") && function_exists("dl"))
  @dl("ldap.so");

if ($command=="editsubmit") {
    $query="";
    reset($glvars);
    foreach ($glvars as $glvar) {
      if ($query)
	$query.=",";
      $query.="('".$glvar."','".SQL_escape($$glvar)."')";
    }
    $query="REPLACE x_global (name,value) VALUES ".$query;
    if (SQL_query($query))
      MsgInfo(x("Global options updated successfully ..."));
    else
      MsgError(x("Error while setting global options."));
  $btn_save="";
  $_SESSION['g_email']=$g_email;
  $_SESSION['g_email_login']=$g_email_login;
  $_SESSION['g_email_bug']=$g_email_bug;
  $_SESSION['g_style']=$style;
  $_SESSION['g_mstyle']=$mstyle;
  $_SESSION['g_msstyle']=$msstyle;
  $_SESSION['g_community']=$community;
  $_SESSION['g_dns']=$dns_allow;
  $_SESSION['g_dnspos']=$dns_pos;
  $_SESSION['g_dnsneg']=$dns_neg;
  $command="";
}



if ($command=="") {
    if (!$btn_save) {
      $res=SQL_query("SELECT name,value FROM x_global");
      if ($res) {
        while (($row=SQL_fetch_row($res))) {
	  $key=array_search($row[0],$glvars);
	  if ($key!==false) {
	    $name=$row[0];
	    $$name=$row[1];
	  }
	}
        SQL_free_result($res);
      }
    }

    /* set default values */
    if (!$ldap_host)
      $ldap_host="ldap://ldap.mycompany.com";
    if (!$ldap_bind)
      $ldap_bind="uid=%u,ou=people,dc=mycompany,dc=com";
    if (!$eauth_cmd)
      $eauth_cmd="/usr/bin/nf_auth_pam %u";
    if (!$util_hist)
      $util_hist=90;
    elseif ($util_hist<30)
      $util_hist=30;
    elseif ($util_hist>360)
      $util_hist=360;

    FormStart();
    
    echo InputHidden("command","editsubmit");


    $multiwin['glb']['glb_basic']=array(x("Basic"));
    $multiwin['glb']['glb_over']=array(x("Overview"));
    $multiwin['glb']['glb_email']=array(x("Email"));
    $multiwin['glb']['glb_dns']=array(x("DNS"));
    $multiwin['glb']['glb_auth']=array(x("Authentication"));
    $multiwin['glb']['glb_grico']=array(x("Graph Icon"));
    multiwin_start();
    multiwin_head($multiwin,'glb',640);


    MTStart('glb_basic',$multiwin['glb']);
    TItem(x("Default skin:"));
    TItem(InputSelect("style",select_list($list_style,$style)));
    TNext();
    TItem(x("Default menu style:"));
    TItem(InputSelect("mstyle",select_list($list_mstyle,$mstyle)));
    TNext();
    TItem(x("Default sub menu style:"));
    TItem(InputSelect("msstyle",select_list($list_msstyle,$msstyle)));
    TNext();
    TItem(x("Default SNMP community:"));
    TItem(Input("community",$community,64));
    TNext();
    TItem(InputCheck("check_update","1",i_chk($check_update)).x("Check for update while logged in"),'COLSPAN="2"');
    TNext();
    TItem(InputCheck("check_db","1",i_chk($check_db)).x("Check for database status while logged in"),'COLSPAN="2"');
    TNext();
    TItem(InputCheck("info_last","1",i_chk($info_last)).x("Display last logins"),'COLSPAN="2"');
    TNext();
    TItem(InputCheck("info_lic","1",i_chk($info_lic)).x("Display license expiration warnings"),'COLSPAN="2"');
    TNext();
    TItem(InputCheck("graph_aa","1",i_chk($graph_aa)).x("Enable graph antialiasing"),'COLSPAN="2"');
    MTEnd();


    MTStart('glb_over',$multiwin['glb']);
    TItem(InputCheck("stat_allow","1",i_chk($stat_allow)).x("Display overview statistic"),'COLSPAN="2"');
    TNext();
    TItem(x("Overviews per row [3-10]:"));
    TItem(Input("stat_cols",$stat_cols,2));
    TNext();
    TItem(InputCheck("util_allow","1",i_chk($util_allow)).x("Display overview utilization graphs"),'COLSPAN="2"');
    TNext();
    TItem(x("Utilization graph history [30-360min]:"));
    TItem(Input("util_hist",$util_hist,3));
    TNext();
    TItem(x("Utilization graph width [93-150]:"));
    TItem(Input("util_sizex",$util_sizex,3));
    TNext();
    TItem(x("Utilization graph height [65-150]:"));
    TItem(Input("util_sizey",$util_sizey,3));
    TNext();
    TItem(InputCheck("util_persec","1",i_chk($util_persec)).x("Utilization graph values per second instead of per minute"),'COLSPAN="2"');
    TNext();
    TItem(InputCheck("util_bits","1",i_chk($util_bits)).x("Utilization graph values in bits instead of in bytes"),'COLSPAN="2"');
    TNext();
    TItem(InputCheck("util_clean","1",i_chk($util_clean)).x("Utilization graph without traffic statistic"),'COLSPAN="2"');
    MTEnd();


    MTStart('glb_email',$multiwin['glb']);
    TItem(x("Administrator email:"));
    TItem(Input("email",$email,64));
    TNext();
    TItem(InputCheck("email_login","1",i_chk($email_login)).x("Email logins to administrator"),'COLSPAN="2"');
    TNext();
    TItem(InputCheck("email_bug","1",i_chk($email_bug)).x("Email bugs to administrator"),'COLSPAN="2"');
    MTEnd();


    MTStart('glb_grico',$multiwin['glb']);
    TItem(ShowLink(x("Import new icon"),PRG_PATH.'src/options/imagestore.php?command=add&grp=_GRAPH_ICON'),'colspan="2" align="left"');
    TNext();
    if (is_array($list_grpico) && count($list_grpico)) {
      TItem(x("Image:"));
      TItem(InputSelect("grpico",select_list(array(x("*** no graph icon ***"))+$list_grpico,$grpico)));
      TNext();
      TItem(x("Position-X:"));
      TItem(Input("grpico_x",$grpico_x,4));
      TNext();
      TItem(x("Position-Y:"));
      TItem(Input("grpico_y",$grpico_y,4));
      TNext();
      TItem(x("Alpha factor [10-100]:"));
      TItem(Input("grpico_alpha",$grpico_alpha,3));
    }
    else {
      echo "<td>\n";
      MsgInfo(x("No graph image available, please, import graphic first."));
      echo "</td>\n";
    }
    MTEnd();


    MTStart('glb_dns',$multiwin['glb']);
    TItem(InputCheck("dns_allow","1",i_chk($dns_allow))."&nbsp;".x("Allow DNS caching"),'colspan="2" align="left"');
    TNext();
    TItem(x("Possitive timeout [min]:"));
    TItem(Input("dns_pos",$dns_pos,5));
    TNext();
    TItem(x("Negative timeout [min]:"));
    TItem(Input("dns_neg",$dns_neg,5));
    TNext();
    MTEnd();


    MTStart('glb_auth',$multiwin['glb']);
    echo "<td>\n";
      WinStart(InputCheck("ldap_allow","1",i_chk($ldap_allow))."&nbsp;".x("LDAP authentication"),'','','','ALIGN="left"');
      if (function_exists('ldap_connect')) {
        TItem(x("LDAP server URL:"));
        TItem(Input("ldap_host",$ldap_host,128,'size="32"'));
        TNext();
        TItem(x("LDAP bind DN:"));
        TItem(Input("ldap_bind",$ldap_bind,128,'size="32"'));
      }
      else {
        echo InputHidden("ldap_host",$ldap_host);
        echo InputHidden("ldap_bind",$ldap_bind);
        echo "<TD>\n";
        MsgInfo(x("LDAP extension is NOT available. Install PHP LDAP extension first."));
        echo "</TD>\n";
      }
      WinEnd();

      echo "<br><br>\n";

      WinStart(InputCheck("eauth_allow","1",i_chk($eauth_allow))."&nbsp;".x("External authentication"),'','','','ALIGN="left"');
      TItem(x("External script:"));
      TItem(Input("eauth_cmd",$eauth_cmd,128));
      WinEnd();

      echo "<br><br>\n";

      WinStart(InputCheck("anon_allow","1",i_chk($anon_allow))."&nbsp;".x("Anonymous login"),'','','','ALIGN="left"');
      TItem(x("Anonymous account:"));
      TItem(InputSelect("anon_user",select_list($list_user,$anon_user)));
      WinEnd();
    echo "</td>\n";
    MTEnd();

    multiwin_tail();
    multiwin_end($multiwin);
    echo "<br/>".InputSubmit("btn_save",x("Save setting"));
    FormEnd();

$u_java=1;

}

MenuEnd();
PageTail();

?>