<?php
define('HELPMARK','config_groups.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');



getGlobalVar('command',$command);
getGlobalVar('c__num',$c__num);
getGlobalVar('btn_save',$btn_save);
getGlobalVar('subdelete',$subdelete);
getGlobalVar('rsubdelete',$rsubdelete);
getGlobalVar('dlg_yes',$dlg_yes);
getGlobalVar('c__sel',$c__sel);

getGlobalVar('id',$id);
getGlobalVar('iid',$iid);
getGlobalVar('name',$name);
getGlobalVar('rights',$rights);
getGlobalVar('comment',$comment);
getGlobalVar('coll',$coll);
getGlobalVar('type',$type);
getGlobalVar('cond',$cond);


$comment=strip_lfcr($comment);

PageHead();
PageLogo();
MenuStart('options','MySubMenu');
PageTitle(x("Group settings"),'i_group.gif');
RequireRights("admin");

$list_rights['admin']=x("Administrator");
$list_rights['options']=x("Configuration");
$list_rights['collector']=x("Collector maintenance");
$list_rights['status']=x("View status");
$list_rights['search']=x("Search statistics");
$list_rights['export']=x("Export data");
$list_rights['profile']=x("Profiles");
$list_rights['shellcmd']=x("Shell commands");
$list_rights['utilmap']=x("Utilization maps");


$list_type['ip']=x("IP address range");
$list_type['if']=x("Interface range");
$list_type['as']=x("AS range");
$list_type['no']=x("No conditions");

$list_coll=array(x("*** ANY ***"))+list_table("x_coll","ORDER BY name");

if ($subdelete)
  $command="delete";
if ($rsubdelete)
  $command="rdelete";

check_command('add','addsubmit','delete','deletesubmit','edit','editsubmit','radd','raddsubmit','rdelete','rdeletesubmit','redit','reditsubmit');
demo_cmd("addsubmit");
demo_cmd("deletesubmit");
demo_cmd("editsubmit");
demo_cmd("raddsubmit");
demo_cmd("rdeletesubmit");
demo_cmd("reditsubmit");





if ($command=="raddsubmit") {
  $v=SQL_escape(array($id,$coll,$type,$cond,$comment));
  if (!req_var($id,x("group ID")))
      $command="";
  elseif (!req_var($type,x("type")))
      $command="radd";
  elseif ($type!='no' && !req_var($cond,x("conditions")))
      $command="radd";
  else {
    if (SQL_query("INSERT INTO x_group_res (id_group,id_coll,type,cond,comment) 
        VALUES('$v[0]','$v[1]','$v[2]','$v[3]','$v[4]')")) {
        MsgInfo(x("Restriction for group ID %d created successfully ..."),$id);
        $command="edit";
	$btn_save="";
    }
    else {
        MsgError(x("Insert failed. Maybe you tried inserting duplicate collector and restriction type."));
        $command="radd";
    }
  }
}


if ($command=="reditsubmit") {
  $v=SQL_escape(array($iid,$coll,$type,$cond,$comment));
  if (!req_var($iid,x("rectriction ID")))
      $command="edit";
  elseif (!req_var($type,x("type")))
      $command="redit";
  elseif ($type!='no' && !req_var($cond,x("conditions")))
      $command="redit";
  else {
    if (SQL_query("UPDATE x_group_res SET id_coll='$v[1]',type='$v[2]',cond='$v[3]',comment='$v[4]' WHERE id='$v[0]'")) {
      MsgInfo(x("Restriction was updated successfully ..."));
      $command="edit";
      $btn_save="";
    }
    else {
      MsgError(x("Update failed. Maybe you tried inserting duplicate collector and restriction type."));
      $command="redit";
    }
  }
}



if ($command=="rdeletesubmit") {
  if (($dlg_yes)&&($c__num)&&($c__sel)) {
    for ($i=0;$i<$c__num;$i++) {
      $iid="";
      getGlobalVar("c__$i",$iid);
      if ($iid) {
	$v=SQL_escape($iid);

        if (!SQL_query("DELETE FROM x_group_res WHERE id='$v'")) {
	    MsgError(x("Delete failed. Group restriction wasn't deleted."));
	    $error=1;
        }	 
      }
    }
    if (!$error)
      MsgInfo(x("Selected restrictions were deleted ...")); 
  }
  $command="edit";
}



if ($command=="addsubmit") {
  $rights_s=implode(",",$rights);
  $v=SQL_escape(array($name,$rights_s,$comment));
  if (!req_var($name,x("name")))
      $command="add";
  else {
    if (SQL_query("INSERT INTO x_group (name,rights,comment) 
        VALUES('$v[0]','$v[1]','$v[2]')")) {
        MsgInfo(x("Group %s created successfully ..."),$name);
	$command="";
    }
    else {
        MsgError(x("Insert failed. Maybe you tried inserting duplicate group name."));
        $command="add";
    }
  }
}


if ($command=="editsubmit") {
  $rights_s=implode(",",$rights);
  $v=SQL_escape(array($name,$rights_s,$comment,$id));
  if (SQL_query("UPDATE x_group SET name='$v[0]',rights='$v[1]',comment='$v[2]' WHERE id='$v[3]'")) {
    MsgInfo(x("Group %s was updated successfully ..."),$name);
    $command="";
  }
  else {
    MsgError(x("Update failed. Maybe you tried inserting duplicate username."));
    $command="edit";
  }
}



if ($command=="deletesubmit") {
  if (($dlg_yes)&&($c__num)&&($c__sel)) {
    for ($i=0;$i<$c__num;$i++) {
      $id="";
      getGlobalVar("c__$i",$id);
      if ($id) {
	$v=SQL_escape($id);

	SQL_query("LOCK TABLE x_group WRITE,x_user READ");

	$res=SQL_query("SELECT name FROM x_group WHERE id='$v'");
	if ($res) {
          $row=SQL_fetch_array($res);
	  $name=$row[0];
          SQL_free_result($res);
        }

	$res=SQL_query("SELECT id FROM x_user WHERE id_grp='$v'");
	if ($res) {
          $numrows=SQL_num_rows($res);
          SQL_free_result($res);
        }

	if ($numrows) {
          MsgError(x("Group %s cannot be deleted, because its in use by %d user(s)."),$name,$numrows); 
	  $error=1;
	}
	else {
          if (!SQL_query("DELETE FROM x_group WHERE id='$v'")) {
	    MsgError(x("Delete failed. Group wasn't deleted."));
	    $error=1;
          }
	  else
    	    SQL_query("DELETE FROM x_group_res WHERE id_group='$v'");
	}

	SQL_query("UNLOCK TABLES");	 
      }
    }
    if (!$error)
      MsgInfo(x("Selected groups were deleted ...")); 
  }
  $command="";
}






if (($command=="radd")||($command=="redit")) {
    if (!$btn_save&&$command=="redit") {
      $v=SQL_escape($iid);
      $res=SQL_query("SELECT id_coll,type,cond,comment FROM x_group_res WHERE id='$v'");
      if ($res) {
        $row=SQL_fetch_array($res);
	$coll=$row[0];
	$type=$row[1];
	$cond=$row[2];
	$comment=$row[3];
        SQL_free_result($res);
      }
    }
    FormStart();
    echo InputHidden("id",$id);
    if ($command=="radd") {
      echo InputHidden("command","raddsubmit");
      WinStart(x("Add new group restriction rule"));
    }  
    else {
      echo InputHidden("iid",$iid);
      echo InputHidden("command","reditsubmit");
      WinStart(x("Edit group restriction rule"));
      TItem(x("ID:"));
      TItem("<B>$iid</B>");
      TNext();
    }
    TItem(x("Group ID:"));
    TItem("<B>$id</B>");
    TNext();
    TItem(x("Collector:"));
    TItem(InputSelect("coll",select_list($list_coll,$coll)));
    TNext();
    TItem(x("Rectriction type:"));
    TItem(InputSelect("type",select_list($list_type,$type)));
    TNext();
    TItem(x("Conditions:"));
    TItem(Input("cond",$cond));
    TNext();
    TItem(x("Comment:"));
    TItem(InputText("comment",$comment));
    TNext();
    TItem("<BR>".InputSubmit("btn_save",x("Save")),'COLSPAN="2" ALIGN="center"');
    WinEnd();
    FormEnd();
}

if ($command=="rdelete") {
  $v=SQL_escape($id);
  if ($c__num) {
    FormStart();
    echo InputHidden("command","rdeletesubmit");
    echo InputHidden("c__num",$c__num);
    echo InputHidden("id",$id);
    $j=0;
    for ($i=0;$i<$c__num;$i++) {
      $c__tmp="";
      getGlobalVar("c__$i",$c__tmp);
      if ($c__tmp) {
        echo InputHidden("c__$i",$c__tmp);
	$j++;
      }
    }
    Dialog(MSGDLG_YESNO,"",x("Do you want to delete the selected restrictions?"));
    echo InputHidden("c__sel",$j);
    FormEnd();
  }
  else
    $command="edit";
}











if (($command=="add")||($command=="edit")) {
    if (!$btn_save&&$command=="edit") {
      $v=SQL_escape($id);
      $res=SQL_query("SELECT name,rights,comment FROM x_group WHERE id='$v'");
      if ($res) {
        $row=SQL_fetch_array($res);
	$name=$row[0];
	$rights_s=$row[1];
	$comment=$row[2];
        SQL_free_result($res);
	$rights=explode(",",$rights_s);
      }
    }
    FormStart();
    JSInvert();

    if ($command=="add") {
      echo InputHidden("command","addsubmit");
      WinStart(x("Add new group"));
    }  
    else {
      echo InputHidden("id",$id);
      echo InputHidden("command","editsubmit");
      WinStart(x("Edit group"));
      TItem(x("ID:"));
      TItem("<B>$id</B>");
      TNext();
    }
    TItem(x("Group name:"));
    TItem(Input("name",$name,32));
    TNext();
    TItem(x("Assigned rights:"));
    TItem(InputSelect("rights[]",select_list($list_rights,$rights),'MULTIPLE'));
    TNext();
    TItem(x("Comment:"));
    TItem(InputText("comment",$comment));
    TNext();
    TItem("<BR>".InputSubmit("btn_save",x("Save")),'COLSPAN="2" ALIGN="center"');
    WinEnd();

    if ($command=="edit") {
      $v=SQL_escape($id);
      $res=SQL_query("SELECT id,id_coll,type,cond,comment FROM x_group_res WHERE id_group='$v' ORDER BY id_coll DESC,type");
      if ($res) {
	if (SQL_num_rows($res)) {
	  echo "<BR><BR>\n";
	  WinStart(x("Restrictions"));
	  THItem(ShowInvert());
	  THItem(x("Collector"));
	  THItem(x("Type"));
	  THItem(x("Conditions"));
	  THItem(x("Comment"));
	  THItem(x("Command"));
	  $i=0;
          while ($row=SQL_fetch_array($res)) {
	    TNext();
	    TItem(InputCheck("c__$i",$row[0]));
	    TItem($list_coll[$row[1]]);
	    TItem($list_type[$row[2]]);
	    TItem(str_strip($row[3]));
	    TItem(str_strip($row[4]));
	    TItem(ShowLink(x("Edit"),"groups.php?command=redit&id=$id&iid=$row[0]"),'ALIGN="center"');
	    $i++;   
          }
          TNext();
    	  TItem("<BR>".InputSubmit("rsubdelete",x("Delete")),'COLSPAN="6" ALIGN="center"');
          WinEnd();
          echo InputHidden("c__num",$i);
	}
        SQL_free_result($res);
      }
    }
    FormEnd();
}


if ($command=="delete") {
  $v=SQL_escape($id);
  if ($c__num) {
    FormStart();
    echo InputHidden("command","deletesubmit");
    echo InputHidden("c__num",$c__num);
    $j=0;
    for ($i=0;$i<$c__num;$i++) {
      $c__tmp="";
      getGlobalVar("c__$i",$c__tmp);
      if ($c__tmp) {
        echo InputHidden("c__$i",$c__tmp);
	$j++;
      }
    }
    Dialog(MSGDLG_YESNO,"",x("Do you want to delete the selected groups?"));
    echo InputHidden("c__sel",$j);
    FormEnd();
  }
  else
    $command="";
}




if ($command=="") {
  $res=SQL_query("SELECT id,name,comment FROM x_group");
  if ($res) {
    if (SQL_num_rows($res)) {
      FormStart();
      JSInvert();
      WinTStart();
      THItem(ShowInvert());
      THItem(x("Name"));
      THItem(x("Comment"));
      THItem(x("Command"));
      $i=0;
      while (($row=SQL_fetch_array($res))) {
        TLine();
	TItem(InputCheck("c__$i",$row[0]));
	TItem($row[1]);
	TItem(str_strip($row[2]));
	TItem(ShowLink(x("Edit"),"groups.php?command=edit&id=$row[0]"),'ALIGN="center"');   
	$i++;
      }
      TNext();
      TItem("<BR>".InputSubmit("subdelete",x("Delete")),'COLSPAN="4" ALIGN="center"');
      WinEnd();
      echo InputHidden("c__num",$i);
      FormEnd();
    }
    else
      MsgInfo(x("No group found ... Please, click on the 'Add' link in the left 'Groups' menu."));
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));
}

MenuEnd();
PageTail();



function MySubMenu() {
  global $command,$id;

  $mysubmenu[]=array('caption'=>x("List"),'url'=>'groups.php');
  $mysubmenu[]=array('caption'=>x("Add"),'url'=>'groups.php?command=add');
  if ($command[0]=="r")
    $mysubmenu[]=array('caption'=>x("Edit group"),'url'=>"groups.php?command=edit&id=$id");
  if ($command=="edit")
    $mysubmenu[]=array('caption'=>x("Add restriction"),'url'=>"groups.php?command=radd&id=$id");
  MenuSub(x("Groups"),$mysubmenu);
}


?>