<?php
define('HELPMARK','config_networks.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');

getGlobalVar('command',$command);
getGlobalVar('import',$import);

getGlobalVar('format',$format);
getGlobalVar('delete',$delete);
getGlobalVar('data',$data);

$data=strip_lfcr($data);

PageHead();
PageLogo();
MenuStart('options','MySubMenu');
PageTitle(x("Network settings - Import networks"),'i_network.gif');
RequireRights("options");


if ($import)
  $command="import";

check_command('preview','import');
demo_cmd("import");

$list_format=array();
$list_format[1]="Start_IP;End_IP;Name;Comment";
$list_format[2]="Start_IP;Network_mask;Name;Comment";
$list_format[3]="IP_common;Name;Comment";



if ($command=="import") {
  if ($delete)
    SQL_query("DELETE FROM x_network");
    
  $query="";
  $d=parse_importnet($format,$data);
  if (count($d)) {
    foreach ($d as $line) {
      if ($line[0] && $line[1]) {
        if ($query)
          $query.=",('".SQL_escape($line[0])."','".SQL_escape($line[1])."','".SQL_escape($line[2])."')";
	else
          $query="('".SQL_escape($line[0])."','".SQL_escape($line[1])."','".SQL_escape($line[2])."')";
      }
    }
    if ($query) {
      if (SQL_query("REPLACE x_network (ip,name,comment) VALUES ".$query))
        MsgInfo(x("Networks imported successfully ..."));
      else
        MsgError(x("Update failed."));
    }
  }
  if (!$query)
    MsgError(x("No network to import."));
  $command="";
}


if ($command=="preview") {
  $d=parse_importnet($format,$data);
  if (count($d)) {
    FormStart();
    WinStart(x("Import preview"));
    THItem(x("IP address range"));
    THItem(x("Network name"));
    THItem(x("Comment"));
    foreach ($d as $line) {
      TLine();
      if ($line[0] && $line[1]) {
	TItem($line[0]);
	TItem($line[1]);
	TItem($line[2]);
      }
      else
	TItem('<b>'.x("Ignoring line:").'</b> '.$line[3],'colspan="3"');
    }
    TNext();
    TItem(InputSubmit("button",x("Back")).'&nbsp;&nbsp;'.InputSubmit("import",x("Import")),'colspan="3" align="center"');
    echo InputHidden('format',$format);
    echo InputHidden('delete',$delete);
    echo InputHidden('data',$data);
    WinEnd();
    FormEnd();
  }
  else {
    MsgError(x("No network to import."));
    $command="";
  }
}


if ($command=="") {
  FormStart();
  WinStart(x("Select data format and import networks"));
  TItem(x("Data format:"));
  TItem(InputSelect("format",select_list($list_format,$format)));
  TNext();
  TItem(InputCheck("delete","1",i_chk($delete)).' '.x("Delete all networks in the database before import."),'colspan="2"');
  TNext();
  TItem(InputText("data",$data,15,70),'colspan="2"');
  TNext();
  TItem("<br/>".InputSubmit("button",x("Continue")),'colspan="2" align="center"');
  WinEnd();
  echo InputHidden('command','preview');
  FormEnd();
}

MenuEnd();
PageTail();



function parse_importnet($format,$data) {
  $ret=array();
  $d=explode("\n",$data);
  foreach ($d as $line) {
    $line=trim($line);
    if ($line) {
      if (strstr($line,';'))
	$sep=';';
      elseif (strstr($line,','))
	$sep=',';
      else
	$sep=' ';
      $f=explode($sep,$line);
      if (is_array($f))
	while (list($key,$val)=each($f))
	  $f[$key]=trim($val);
      switch ($format) {
	case 1: $ip=$f[0].'-'.$f[1]; $name=$f[2]; $comment=$f[3]; break;
	case 2: $ip=$f[0].'/'.$f[1]; $name=$f[2]; $comment=$f[3]; break;
	case 3: 
	default:$ip=$f[0]; $name=$f[1]; $comment=$f[2]; break;
      }
      $ret[]=array($ip,$name,$comment,$line);
    }
  }
  return $ret;
}



function MySubMenu() {
  $mysubmenu[]=array('caption'=>x("List"),'url'=>'networks.php');
  $mysubmenu[]=array('caption'=>x("Add"),'url'=>'networks.php?command=add');
  $mysubmenu[]=array('caption'=>x("Import"),'url'=>'networks_imp.php');
  MenuSub(x("Networks"),$mysubmenu);
}

?>
