<?php
define('HELPMARK','config_users.html');
define('PRG_PATH','../../');
require_once(PRG_PATH . 'core/main.php');

getGlobalVar('command',$command);
getGlobalVar('c__num',$c__num);
getGlobalVar('btn_save',$btn_save);
getGlobalVar('subdelete',$subdelete);
getGlobalVar('dlg_yes',$dlg_yes);
getGlobalVar('c__sel',$c__sel);

getGlobalVar('id',$id);
getGlobalVar('username',$username);
getGlobalVar('password',$password);
getGlobalVar('email',$email);
getGlobalVar('enable',$enable);
getGlobalVar('admin',$admin);
getGlobalVar('id_grp',$id_grp);
getGlobalVar('lang',$lang);
getGlobalVar('comment',$comment);
getGlobalVar('graph_x',$graph_x);
getGlobalVar('graph_y',$graph_y);
getGlobalVar('graph_theme',$graph_theme);
getGlobalVar('style',$style);
getGlobalVar('java',$java);
getGlobalVar('timezone',$timezone);

$comment=strip_lfcr($comment);

PageHead();
PageLogo();
MenuStart('options','MySubMenu');
PageTitle(x("User settings"),'i_user.gif');
RequireRights("admin");

if ($subdelete)
  $command="delete";

check_command('add','addsubmit','delete','deletesubmit','edit','editsubmit');
demo_cmd("addsubmit");
demo_cmd("deletesubmit");
demo_cmd("editsubmit");

$list_group=list_table('x_group',"ORDER BY name");
if (count($list_group)==0)
  MsgFatal(x("No group defined, create group first."));

$list_java[0]=x("autodetect");
$list_java[1]=x("always ON");
$list_java[2]=x("always OFF");

while (list($key,$val) = each($themearr))
  $list_theme[$key]=$key;
$list_style=load_styles();


if ($command=="addsubmit") {
  $v=SQL_escape(array($username,$password,$email,$enable,$id_grp,$lang,$comment,$graph_x,$graph_y,$graph_theme,$style,$java,$timezone,$admin));
    if (!req_var($username,x("username")))
      $command="add";
    else {
      SQL_query("LOCK TABLE x_user WRITE,x_group READ");
      if (check_id("x_group",$id_grp)) {
        MsgError(x("Selected group not found ..."));
	$command="add";
      }
      else
      if (SQL_query("INSERT INTO x_user (name,pass,email,enable,id_grp,lang,comment,graph_x,graph_y,graph_theme,style,java,timezone,admin) 
        VALUES('$v[0]',password('$v[1]'),'$v[2]','$v[3]','$v[4]','$v[5]','$v[6]','$v[7]','$v[8]','$v[9]','$v[10]','$v[11]','$v[12]','$v[13]')")) {
        MsgInfo(x("User %s created successfully ..."),$username);
        $command="";
      }
      else {
        MsgError(x("Insert failed. Maybe you tried inserting duplicate username."));
        $command="add";
      }
      SQL_query("UNLOCK TABLES");
    }
}


if ($command=="editsubmit") {
    $v=SQL_escape(array($password,$email,$enable,$id_grp,$lang,$comment,$graph_x,$graph_y,$graph_theme,$style,$java,$timezone,$admin,$id));
    SQL_query("LOCK TABLE x_user WRITE,x_group READ");
    if (check_id("x_group",$id_grp)) {
        MsgError(x("Selected group not found ..."));
	$command="edit";
    }
    else {
      if ($password)
        $query="UPDATE x_user SET pass=password('$v[0]'),email='$v[1]',enable='$v[2]',id_grp='$v[3]',
      lang='$v[4]',comment='$v[5]',graph_x='$v[6]',graph_y='$v[7]',graph_theme='$v[8]',style='$v[9]',java='$v[10]',timezone='$v[11]',admin='$v[12]' WHERE id='$v[13]'";
      else
        $query="UPDATE x_user SET email='$v[1]',enable='$v[2]',id_grp='$v[3]',
      lang='$v[4]',comment='$v[5]',graph_x='$v[6]',graph_y='$v[7]',graph_theme='$v[8]',style='$v[9]',java='$v[10]',timezone='$v[11]',admin='$v[12]' WHERE id='$v[13]'";
      if (SQL_query($query)) {
        MsgInfo(x("Username %s was updated successfully ..."),$username);
        $command="";
      }
      else {
        MsgError(x("Update failed. Maybe you tried inserting duplicate username."));
        $command="edit";
      }
    }
    SQL_query("UNLOCK TABLES");

}



if ($command=="deletesubmit") {
  $error=0;
  if (($dlg_yes)&&($c__num)&&($c__sel)) {
    for ($i=0;$i<$c__num;$i++) {
      $id="";
      getGlobalVar("c__$i",$id);
      if ($id) {
        if ($id==$u_id) {
          MsgError(x("You can't delete your current account!"));
	  $error=1;
        }
        else {
	  $v=SQL_escape($id);	
          if (!SQL_query("DELETE FROM x_user WHERE id='$v'")) {
	    MsgError(x("Delete failed. User wasn't deleted."));
	    $error=1;
          }
        }	 
      }
    }
    if (!$error)
      MsgInfo(x("Selected users were deleted ...")); 
  }
  $command="";
}




if (($command=="add")||($command=="edit")) {
    if (!$btn_save&&$command=="edit") {
      $v=SQL_escape($id);
      $res=SQL_query("SELECT name,pass,email,enable,id_grp,lang,comment,graph_x,graph_y,graph_theme,style,java,timezone,admin FROM x_user WHERE id='$v'");
      if ($res) {
        $row=SQL_fetch_array($res);
	$username=$row[0];
	$email=$row[2];
	$enable=$row[3];
	$id_grp=$row[4];
	$lang=$row[5];
	$comment=$row[6];
	$graph_x=$row[7];
	$graph_y=$row[8];
	$graph_theme=$row[9];
	$style=$row[10];
	$java=$row[11];
	$timezone=$row[12];
	$admin=$row[13];
        SQL_free_result($res);
      }
    }
    FormStart();
    echo InputHidden("id",$id);
    if ($command=="add") {
      echo InputHidden("command","addsubmit");
      WinStart(x("Add new user"));
      TItem(x("Username:"));
      TItem(Input("username",$username,32));
      TNext();
    }  
    else {
      echo InputHidden("command","editsubmit");
      echo InputHidden("username",$username);
      WinStart(x("Edit user"));
      TItem(x("ID:"));
      TItem("<B>$id</B>");
      TNext();
      TItem(x("Username:"));
      TItem("<B>".$username."</B>");
      TNext();
    }
    TItem(x("Password:"));
    TItem(Input("password","",32));
    TNext();
    TItem(x("E-mail:"));
    TItem(Input("email",$email,64));
    TNext();
    TItem(x("Language:"));
    TItem(InputSelect("lang",select_list($list_lang,$lang)));
    TNext();
    TItem(x("Group:"));
    TItem(InputSelect("id_grp",select_list($list_group,$id_grp)));
    TNext();
    TItem(x("Enable account:"));
    TItem(InputCheck("enable","1",i_chk($enable)));
    TNext();
    TItem(x("Administrator:"));
    TItem(InputCheck("admin","1",i_chk($admin)));
    if (count($list_style) > 1) {    
      TNext();    
      TItem(x("Skin:"));
      TItem(InputSelect("style",select_list($list_style,$style)));
    }
    TNext();    
    TItem(x("Graph resolution X:"));
    TItem(Input("graph_x",$graph_x));
    TNext();    
    TItem(x("Graph resolution Y:"));
    TItem(Input("graph_y",$graph_y));
    if (count($list_theme) > 1) {    
      TNext();    
      TItem(x("Graph theme:"));
      TItem(InputSelect("graph_theme",select_list($list_theme,$graph_theme)));
    }
    TNext();
    TItem(x("JavaScript:"));
    TItem(InputSelect("java",select_list($list_java,$java)));
    TNext();
    TItem(x("Timezone:"));
    TItem(Input("timezone",$timezone,32));
    TNext();
    TItem(x("Comment:"));
    TItem(InputText("comment",$comment));
    TNext();
    TItem("<BR>".InputSubmit("btn_save",x("Save")),'COLSPAN="2" ALIGN="center"');
    WinEnd();
    if (count($list_style) <= 1)
      echo InputHidden('style',$style);
    if (count($list_theme) <= 1)
      echo InputHidden('graph_theme',$graph_theme);
    FormEnd();
    
    if (PRG_AUTHTYPE)
      MsgInfo(x("Password is ignored, external authentication is used ..."));
}


if ($command=="delete") {
  $v=SQL_escape($id);
  if ($c__num) {
    FormStart();
    echo InputHidden("command","deletesubmit");
    echo InputHidden("c__num",$c__num);
    $j=0;
    for ($i=0;$i<$c__num;$i++) {
      $c__tmp="";
      getGlobalVar("c__$i",$c__tmp);
      if ($c__tmp) {
        echo InputHidden("c__$i",$c__tmp);
	$j++;
      }
    }
    Dialog(MSGDLG_YESNO,"",x("Do you want to delete the selected users?"));
    echo InputHidden("c__sel",$j);
    FormEnd();
  }
  else
    $command="";
}



if ($command=="") {
  $res=SQL_query("SELECT id,name,enable,id_grp,comment FROM x_user ORDER BY id_grp,name");
  if ($res) {
    if (SQL_num_rows($res)) {
      FormStart();
      JSInvert();
      WinTStart();
      THItem(ShowInvert());
      THItem("");
      THItem(x("Username"));
      THItem(x("Group"));
      THItem(x("Comment"));
      THItem(x("Command"));
      $i=0;
      while (($row=SQL_fetch_array($res))) {
        TLine();
	TItem(InputCheck("c__$i",$row[0]));
	if ($row[2])
	  TItem(ShowImage(x("enabled"),PRG_PATH.'images/ic_gl.gif'));
	else
	  TItem(ShowImage(x("disabled"),PRG_PATH.'images/ic_rl.gif'));
	TItem($row[1]);
	TItem($list_group[$row[3]]);
	TItem(str_strip($row[4]));
	TItem(ShowLink(x("Edit"),"users.php?command=edit&id=$row[0]"),'ALIGN="center"');   
	$i++;
      }
      TNext();
      TItem("<BR>".InputSubmit("subdelete",x("Delete")),'COLSPAN="6" ALIGN="center"');
      WinEnd();
      echo InputHidden("c__num",$i);
      FormEnd();
    }
    else
      MsgInfo(x("No user found ... Please, click on the 'Add' link in the left 'Users' menu."));
    SQL_free_result($res);
  }
  else
    MsgError(x("Database error"));
}

MenuEnd();
PageTail();



function MySubMenu() {
  $mysubmenu[]=array('caption'=>x("List"),'url'=>'users.php');
  $mysubmenu[]=array('caption'=>x("Add"),'url'=>'users.php?command=add');
  MenuSub(x("Users"),$mysubmenu);
}


?>